Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.instruct
Class Attribute

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.SimpleNodeConstructor
                  net.sf.saxon.instruct.Attribute

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator, TailCallReturner

public final class Attribute
extends SimpleNodeConstructor

An instruction derived from an xsl:attribute element in stylesheet, or from an attribute constructor in XQuery

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.instruct.SimpleNodeConstructor
`select`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`Attribute(Expression attributeName, Expression namespace, NamespaceResolver nsContext, int validationAction, SimpleType schemaType, int annotation, boolean allowNameAsQName)` Construct an Attribute instruction

Method Summary
`void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`int` | `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`void` | `display(int level, NamePool pool, java.io.PrintStream out)` Display this instruction as an expression, for diagnostics
`protected int` | `evaluateNameCode(XPathContext context)`
`int` | `getCardinality()` Determine the static cardinality of the expression.
`int` | `getInstructionNameCode()` Get the name of this instruction
`ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the items returned by evaluating this instruction
`java.util.Iterator` | `iterateSubExpressions()` Get the subexpressions of this expression
`void` | `localTypeCheck(StaticContext env, ItemType contextItemType)`
`TailCall` | `processLeavingTail(XPathContext context)` Process this instruction
`protected void` | `promoteInst(PromotionOffer offer)` Offer promotion for subexpressions.
`void` | `setRejectDuplicates()` Indicate that two attributes with the same name are not acceptable.
`Expression` | `simplify(StaticContext env)` Simplify an expression.

Methods inherited from class net.sf.saxon.instruct.SimpleNodeConstructor
`checkContent, createsNewNodes, evaluateItem, expandChildren, getSelect, iterate, optimize, setSelect, typeCheck`

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, assembleParams, assembleTunnelParams, computeCardinality, dynamicError, evaluateAsString, getImplementationMethod, getInstructionInfo, getSourceLocator, isXSLT, process, promote`

Methods inherited from class net.sf.saxon.expr.ComputedExpression
`adoptChildExpression, computeDependencies, computeStaticProperties, doPromotion, dynamicError, dynamicError, effectiveBooleanValue, getColumnNumber, getConstructType, getDependencies, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, suppressValidation, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### Attribute

    public Attribute(Expression attributeName,
                     Expression namespace,
                     NamespaceResolver nsContext,
                     int validationAction,
                     SimpleType schemaType,
                     int annotation,
                     boolean allowNameAsQName)

  Construct an Attribute instruction

Parameters:
  `attributeName` - An expression to calculate the attribute name
  `namespace` - An expression to calculate the attribute namespace
  `nsContext` - a NamespaceContext object containing the static namespace context of the stylesheet instruction
  `validationAction` - e.g. validation=strict, lax, strip, preserve
  `schemaType` - Type against which the attribute must be validated. This must not be a namespace-sensitive type; it is the caller's responsibility to check this.
  `annotation` - Integer code identifying the type named in the `type` attribute
  `allowNameAsQName` -

Method Detail

### setRejectDuplicates

    public void setRejectDuplicates()

  Indicate that two attributes with the same name are not acceptable. (This option is set in XQuery, but not in XSLT)

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction

  Overrides:
    `getInstructionNameCode` in class `Instruction`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Description copied from class: `Instruction`
  Get the item type of the items returned by evaluating this instruction

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `Instruction`
  Parameters:
    `th` -
  Returns:
    the static item type of the instruction

### getCardinality

    public int getCardinality()

  Description copied from class: `ComputedExpression`
  Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.

  Specified by:
    `getCardinality` in interface `Expression`
  Overrides:
    `getCardinality` in class `ComputedExpression`
  Returns:
    one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `SimpleNodeConstructor`
  Returns:
    a set of flags indicating static properties of this expression

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Description copied from class: `Instruction`
  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.

  Specified by:
    `simplify` in interface `Expression`
  Overrides:
    `simplify` in class `SimpleNodeConstructor`
  Throws:
    `XPathException`

### localTypeCheck

    public void localTypeCheck(StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Specified by:
    `localTypeCheck` in class `SimpleNodeConstructor`
  Throws:
    `XPathException`

### iterateSubExpressions

    public java.util.Iterator iterateSubExpressions()

  Get the subexpressions of this expression

  Specified by:
    `iterateSubExpressions` in interface `Expression`
  Overrides:
    `iterateSubExpressions` in class `SimpleNodeConstructor`
  Returns:
    an iterator over the subexpressions

### promoteInst

    protected void promoteInst(PromotionOffer offer)
                        throws XPathException

  Offer promotion for subexpressions. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

  Overrides:
    `promoteInst` in class `SimpleNodeConstructor`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Throws:
    `XPathException` - if any error is detected

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Specified by:
    `checkPermittedContents` in interface `Expression`
  Overrides:
    `checkPermittedContents` in class `ComputedExpression`
  Throws:
    `XPathException`

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Process this instruction

  Specified by:
    `processLeavingTail` in interface `TailCallReturner`
  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - the dynamic context of the transformation
  Returns:
    a TailCall to be executed by the caller, always null for this instruction
  Throws:
    `XPathException`

### evaluateNameCode

    protected int evaluateNameCode(XPathContext context)
                            throws XPathException,
                                   XPathException

  Overrides:
    `evaluateNameCode` in class `SimpleNodeConstructor`
  Throws:
    `XPathException`

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Display this instruction as an expression, for diagnostics

  Specified by:
    `display` in interface `Expression`
  Overrides:
    `display` in class `SimpleNodeConstructor`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD